#!/usr/bin/perl 
use Cwd;
################
# Name: AutoSim4.pl  Copyright@ Jack Min, YSU
#
$sim4 = "/home/jack/Tools/Others/sim4/sim4";  #"/home/tools/sim4/sim4"; #sim4 path, plese change the path if it is installed in different directory
#
#
if ($#ARGV != 3)
{
	print "usage: AutoSim4.pl genome_input est_input identity len\n";
	print "   	genome_input: genomic sequence in fasta file - can have multiple sequences\n";
	print "	  	est_input: est sequences in fasta file\n";
	print "		identity: minimium identity of mapping (85 - 97)\n";
	print "		len: minimium of aligned length (>=80 bp)\n";
	exit;
}
# input
$gFile = $ARGV[0];
$eFile = $ARGV[1];
$uIdentity = $ARGV[2];
$uLen = $ARGV[3];
print "In progress ...\n";
open (IN, $gFile) || die "Cannot open file $gFile\n";
$flag = 0;
$count = 0;
$seqID = '';
@fA = ();
$dir = getcwd();
system ("mkdir tmp");
chmod 0777, tmp;
$gPath = $dir."/tmp/";
print "splitting genomes ....\n";
while (<IN>)
{
	$line = $_;
	if ($line =~ /^>/)
	{
		$count++;
		if ($count > 1)
		{
		close (OUT);
		}
		#print $line."\n";
		@tmp = split (/\s+/, $line);
		$id = $tmp[0];
		$fid = substr($id, 1);
		if ($fid =~ /\|/)
		{
			@tmp1 = split(/\|/, $fid);
			$fid = $tmp1[0]."_".$tmp1[1];	
		}
		$line = ">".$fid."\n";	
		$file = $gPath.$fid;
		print $file."\n";
		push (@fA, $fid);
		print OUT ("\n");
		open (OUT, ">$file");
		print OUT ($line);
	}
	else
	{
		$line =~ s/[\r\f]//;
		$line = uc($line);
		print OUT ($line);
	}
}
close (IN);
close (OUT);
print "total sequences: ".$count."\n";
$estSeq = $eFile;
system ("mkdir out");
chmod 0777, out;
$outP = $dir."/out/";
$outPath = "> $outP";

$int = 0;
@simF = ();

foreach $file (@fA)
{
	$fName = $gPath.$file;
	print $fName."\n";	
	system ("$sim4 $fName $estSeq P=1 A=3 $outPath$file.'sim'");
}

system ("mkdir save");
chmod 0777, save;
$sDir = $dir."/save/";
foreach $file (@fA)
{
	$inF = $outP.$file.".sim";
	$outF = $outP.$file.".parse";
	$outF2 = $sDir."/est2genome.gtf";
	$allParse = $sDir."/est2genome_align.txt";
	print "parsing .....\n";
	system "perl $dir/sim2gtf.pl $inF $outF $outF2 $uIdentity $allParse";
}
foreach $file (@fA)
{
	print "clustering .....\n";
	$inF = $outP.$file.".parse.exon";
	$outF = $sDir."/high_similarity_clusters.txt";
	$outF2 = $sDir."/AS_clusters.txt";
	system "perl $dir/sim4cluster.pl $inF $outF $outF2 $uLen";
}
$inF1 = $sDir."/est2genome.gtf";$inF2 = $sDir."/AS_clusters.txt"; $outF = $sDir."/AS.gtf";
system ("perl $dir/extractASgtf.pl $inF1 $inF2 $outF");
#system "rm -rf $outP";
print "all done\n";
exit;
