#!/usr/bin/perl
#use strict;
#updated on June 10 to include strand value in exon output
########### code body ###########
if ($#ARGV != 4)
{
	print "\n";
	print "usage: sim2gff.pl sim4input individual.parse all_gff identity all_parse\n";
	print "\t\t sim4input: sim4 ouput file after run sim4Parser as input\n";
	print "\t\t out.gff: output file in '.gff' format\n";
	exit;
}

$inF = $ARGV[0];
$outF = $ARGV[1];
$outF3 = $ARGV[2]; #combined gff
$uIdentity = $ARGV[3];
$allParse = $ARGV[4];
@inA = ();
open (IN, "$inF"); # || die ("Can't open $inF");
@inA = <IN>;
close(IN);

@outA = ();
$count = 0;
$flag = 0; #flag for %sign
$data = '';
$exonNum = 0; # ? to show the number of exons on for one gene, if only one exon aligned, discard it.
$length = 0;
$totalLength = 0;
$estLength = 0;
$identity = 0;
$iFlag = 0;
#while (<IN>) #
foreach $line (@inA)
{ #foreach
	if ($line =~ /seq1 =/)
	{
		$count++;
		$flag = 0;
		$exonNum = 0;
		$data = $line;
		$length = 0;
		$totalLength = 0;
		$coverage = 0;
		$estLength = 0;
		$iFlag = 1;
	}
	elsif ($line =~ /seq2 =/)
	{
		@tmpA = split (/ /, $line);
		$estLength = $tmpA[4];
		$data .= $line;
	}
	elsif ($line =~ /\%/)
	{
		$flag = 1;
		$exonNum++;
		@tmp = split (/\s+/, $line);
		@tmp2 = split (/\-/, $tmp[0]);
		$length = $tmp2[1] - $tmp2[0];
		$totalLength = $totalLength + $length;
		$data .= $line;
		$identity = 1* $tmp[2];
		if ($identity < $uIdentity)
		{
			$iFlag = 0;
		}
	        if (($line =~ /\->/) || ($line =~ /\<-/) || ($line =~ /==/))
                {
                        $endFlag = 0;
                }
                else
                {
                        $endFlag = 1; # end of the section of alignment co-ordinator
                	$coverage = $totalLength/$estLength *100; #
                        if (($coverage >= 85) && ($iFlag == 1))
                        {
                                push (@outA, $data);
                        }
		}
	}
	else
	{
		$data .= $line;
	}
} #while

open(OUT, ">$outF");
print OUT (@outA);
close (OUT);
## print all_parse
open(OUT, ">>$allParse");
print OUT (@inA);
close (OUT);
###
@inA = ();
open (IN, "$outF"); # || die ("Can't open $inF");
@inA = <IN>;
close (IN);
############ processing parsing data ######
$flag = 0;
$seqLength = 0;
$start = 0;
$end = 0;
$frame = ".";
$similarity = 0;
$note = '';
$endFlag = 0;
$strend = '+';
@outA2 = ();
foreach $line (@inA)
{
	if ($line =~ /^seq1/)
	{
		@tmp = split(/\s+/, $line);
		$t = $tmp[2];
		@tmp2 = split(/\,/, $t);
		$gSeq = $tmp2[0];
		$endFlag = 0;
		$exon = '';
		if ($gSeq =~ /\//)
		{
			@tmp3 = split(/\//, $gSeq);
			$gID = pop (@tmp3);
		}
	}
	elsif ($line =~ /^seq2/)
	{
		@tmp = split(/\(/, $line);
		$t1 = $tmp[1];
		@tmp3 = split(/\)/, $t1);
		$eID = $tmp3[0]; $strand = '+';
		$gapFlag = 0;
	}
	elsif ($line =~ /complement/)
	{
		$strand = '-';
	}
	elsif ($line =~ /\%/)
	{
		if ($line =~ /\->/)
		{
			$strand = '+';
		}
		elsif ($line =~ /\<-/)
		{
			$strand = '-';
		}
		elsif ($line =~ /==/)
		{
			$note = "internal fragment unaligned";
			$gapFlag = 1;
		}
		else
		{
			$endFlag = 1; # end of the section of alignment co-ordinator
		}

		@tmp = split (/\s+/, $line);
		####### coordinates of genomes
		$t1 = $tmp[0]; #start-end
		@tmp2 = split (/\-/, $t1);
		$start = $tmp2[0];
		$end = $tmp2[1];
		###### coordinates of est
		$t2 = $tmp[1];
		$t2 =~ s/\(//;
		$t2 =~ s/\)//;
		@tmp3 = split(/\-/, $t2);
		$eStart = $tmp3[0];
		$eEnd = $tmp3[1];
		######## similarity #######
		$similarity = $tmp[2]*1;
#		$in  = $gID."\t".$eID."\t".$start."\t".$end."\t".$eStart."\t".$eEnd."\t".$similarity."\t".$strand."\t".$note."\n";
		$in = $gID."\t".$similarity."\t"."exon"."\t".$start."\t".$end."\t"."."."\t".$strand."\t".$eStart."-".$eEnd."\t".'transcript_id "'.$eID.'"; '.$note."\n";

		if ($endFlag == 1)
		{
			if ($similarity > 95)
			{
				$exon .= $start.":".$end;
			}
			push (@outA3, $gID."\t".$eID."\t".$strand."\t".$exon."\n"); #added strand value
			$exon = '';
 		}
		else
		{
			if ($similarity > 90)
			{
				$exon .= $start.":".$end." ";
			}
		}
		push (@outA2, $in);
		$note  = '';
	}
}

#generate gff file
open(OUT, ">>$outF3");
print OUT (@outA2);
close (OUT);
$outF4 = $outF.".exon";
open(OUT, ">$outF4");
print OUT (@outA3);
close (OUT);

#print "The job is done!\n";

exit;





