#!/usr/bin/perl
#################################
# updated on June 10 to include strand valude for comparison
#Program: check overlapped exons within one set of ides
# revised to add genomic DNA ids in the clusters
#################################
if ($#ARGV != 3)
{
	print "Usage: cluster_sim4.pl exon.file cluster AS_clusters overlap_length \n";
	#input: exon.file; overlap_length
	#output: clusters; AS_clusters 
	exit;
}

$inF = $ARGV[0];
$outF = $ARGV[1]; #clusters
$asF = $ARGV[2]; #AS-clusters
$uLen = $ARGV[3];
open (IN, $inF) || die ("Cannot open file $inF !!\n");
@exonA = <IN>;
close (IN);

if ($uLen < 80)
{
	$uLen = 80;
}

####### identify overlapping ESTs
$exA = (); #overlapping ESTs
foreach $line (@exonA)
{
	chomp($line);
	@t = split(/\t/, $line);
	$gID = $t[0];
	$eID = $t[1];
	$strand1 = $t[2];
	$exon = $t[3];	
   	@t1 = split(/\:/, $exon);
	$gStart  = $t1[0];
	$gEnd    = pop (@t1);
	$oFlag = 0; # overlap flag

################
	foreach $e (@exonA)
	{
		chomp ($e);
		@t2 = split(/\t/, $e);
		$gID2 = $t2[0];
		$eID2 = $t2[1];
		$strand2 = $t2[2];
		$exon2 = $t2[3];	
   		@tE = split(/\:/, $exon2);
		$gStart2  = $tE[0];
		$gEnd2    = pop (@tE);
		if (($gID ne $gID2))# || ($strand1 ne $strand2))
		{
			next;
		}
		else
		{
			if ($eID eq $eID2)
			{
				next;
			}
			else
			{
				if (($gStart <= $gEnd2) && ($gEnd > $gStart2)) #there is an overlap
				{ 		
						if ($gStart > $gStart2)
						{
							$len = $gEnd2 - $gStart; #overlap length
						}
						else
						{
							if ($gEnd >= $gEnd2)
							{
								$len = $gEnd2 - $gStart2;
							}
							else
							{
								$len = $gEnd - $gStart2;
							}
						}
						if ($len > $uLen)  
						{
							push (@outA, $gID."\t".$eID."\t".$eID2."\n");
							push (@exA, $line."\t".$e."\n");
							#print $line."\t".$e."\n";
						}
				}
			}
		}
	}
}

################# clustering the overlapping ESTs ################
$flag = 0;
foreach $entry (@outA)
{
	chomp $entry;
	$int++;
	$flag = 0;
	@tmp = split (/\t/, $entry);
	$gID = $tmp[0]; #genome id
	$q = $tmp[1];
	$s = $tmp[2];
	$qFlag = 0;
	$sFlag = 0;
   if ($int == 1)
   {
	push (@aOut, $gID."\t".$q." ".$s."\n");
	push (@aOut2,$gID."\t".$q." ".$s."\n");
   }
  else
  {
	$count = 0;
	foreach $line (@aOut)
	{
		chomp ($line);
		@tAA = split(/\t/, $line);
		@tmp2 = split(/ /, $tAA[1]);
		$count++;
		foreach $item (@tmp2)
		{
			if ($item eq $q)
			{
				$qFlag = 1;
			}
			if ($item eq $s)
			{
				$sFlag = 1;
			}
		}
		if ($qFlag == 1 || $sFlag == 1)
		{
			last;
		}
	}

	$x = ($aOut[$count-1]);
	#print $x."\n";
	if ($sFlag == 0 && $qFlag == 0)
	{
		push (@aOut, $gID."\t".$q." ".$s."\n");
		push (@aOut2, $gID."\t".$q." ".$s."\n");
	}
	if ($sFlag == 0 && $qFlag == 1)
	{
		$aOut[$count-1] = $x." ".$s."\n";
		$aOut2[$count-1] = $x." ".$s."\n";
	}
	if ($sFlag == 1 && $qFlag == 0)
	{
		$aOut[$count -1] = $x." ".$q."\n";
		$aOut2[$count-1] = $x." ".$q."\n";
	}
 }
}
#open (OUTPUT, ">>$outF");
#print OUTPUT (@aOut2);
#close OUTPUT;
###### identifying AS ESTs (check introns)
@asA = ();
foreach $line (@exA) #f 149
{
	chomp($line);
#	print $line."\n";
	@t = split(/\t/, $line);
	$gID = $t[0]; #genome id
	$id1 = $t[1]; $e1 = $t[3]; #exons of the 1st EST
	$id2 = $t[5]; $e2 = $t[7]; #exons of the 2nd EST
	#print $e1."\n";
	#print $e2."\n";
	@eT1 = split(/\s+/, $e1);
	@eT2 = split(/\s+/, $e2);
	$size1 = @eT1; #size
	$size2 = @eT2; 	
	$asFlag = 0;
	if (($size1 == 1) && ($size2 == 1))
	{
		next;
	}
	else
	{ #e 164
		$int1 = 0;
		foreach $exon (@eT1) #f180
		{
			$int1++;
			@x1 = split(/\:/, $exon);
			$s1 = $x1[0]; #s: start; e-end of an exon
			$e1 = $x1[1];
			#print $id1." est1 start:".$s1." end:".$e1."\n";
			$int2 = 0;
			foreach $exon2 (@eT2) #f188
			{
				$int2++;
				@x2 = split(/\:/, $exon2);
				$s2 = $x2[0];
				$e2 = $x2[1];
				#print $id2." est2 start:".$s2." end:".$e2."\n";
				if ($e1 > $s2 && $s1 < $e2)  # e1 > s2 overlapping
				{ #f196
					#print $id2." est2 start:".$s2." end:".$e2."\n";
					if ($s1 != $s2 ) #&& ($int1 != 1 || $int2 != 1))
					{
						if ($int1 != 1  && $int2 !=1)
						{
							$asFlag = 1;  #print "int1: ".$int1."\t"." int2:".$int2."\n"; 
							#print "asFlag 202: ".$asFlag."\n";
						}
					}	
					if ($e1 != $e2) ##
					{
						if (($int1 != $size1 || $int2 != $size2))
						{
							#print $int1."\t".$size1."\t".$int2."\n";
							$asFlag = 1; #print "asFlag 209: ".$asFlag."\n";
						}
					}
					if ($asFlag ==1)
					{
						push (@asA, $gID."\t".$id1."\t".$id2."\n"); 
						last;
					}
				}
			}
			if ($asFlag == 1)
			{
				last;
			}
		} #f180
	}#e 164
} #f 149  	
#clustering as
$flag = 0;
@aO = ();
@aO3 = ();
$int = 0;
foreach $entry (@asA)
{
	chomp $entry;
	$int++;
	$flag = 0;
	@tmp = split (/\t/, $entry);
	$gID = $tmp[0];
	$q = $tmp[1];
	$s = $tmp[2];
	$qFlag = 0;
	$sFlag = 0;
   if ($int == 1)
   {
	push (@aO, $gID."\t".$q." ".$s."\n");
	push (@aO3, $gID."\t".$q." ".$s."\n");
   }
  else
  {
	$count = 0;
	foreach $line (@aO)
	{
		chomp ($line);
		@tmp2A = split(/\t/, $line);
		@tmp2 = split(/ /, $tmp2A[1]);
		$count++;
		foreach $item (@tmp2)
		{
			if ($item eq $q)
			{
				$qFlag = 1;
			}
			elsif ($item eq $s)
			{
				$sFlag = 1;
			}
		}
		if ($qFlag == 1 || $sFlag == 1)
		{
			last;
		}
	}

	$x = ($aO[$count-1]);
	if ($sFlag == 0 && $qFlag == 0)
	{
		push (@aO, $gID."\t".$q." ".$s."\n");
		push (@aO3, $gID."\t".$q." ".$s."\n");
	}
	if ($sFlag == 0 && $qFlag == 1)
	{
		$aO[$count-1] = $x." ".$s."\n";
		$aO3[$count-1] = $x." ".$s."\n";
	}
	if ($sFlag == 1 && $qFlag == 0)
	{
		$aO[$count -1] = $x." ".$q."\n";
		$aO3[$count-1] = $x." ".$q."\n";
	}
 }
}
open (OUTPUT, ">>$asF");
print OUTPUT (@aO3);
close OUTPUT;
exit;


